Attribute VB_Name = "mdlResizing"
'MODULE TO MAKE RESIZE
'Tamas Balogh
'OCT-2002
't_balogh@hotmail.com

Option Explicit

Public Enum enmResizing
  eAnchorTo_Nothing
  eAnchorTo_TopLeft
  eAnchorTo_TopRight
  eAnchorTo_TopLeftRight
  eAnchorTo_BottomLeft
  eAnchorTo_BottomRight
  eAnchorTo_BottomLeftRight
  eAnchorTo_TopBottomLeft
  eAnchorTo_TopBottomRight
  eAnchorTo_All
End Enum

Public Function DoResizeControls(ByRef ThisForm As Form) As Boolean

  On Error GoTo Exc_Handler
  
  If (ThisForm Is Nothing) _
  Or Not ThisForm.Visible Then
    DoResizeControls = True
    Exit Function
  End If
  'If form is minimized, then exit
  If ThisForm.WindowState = vbMinimized Then
    DoResizeControls = True
    Exit Function
  End If
  'call the function
  Call DoResizeChildControls(ThisForm, ThisForm, ThisForm.FormOldWidth, ThisForm.FormOldHeight)
  'Save new size
  ThisForm.FormOldWidth = ThisForm.Width
  ThisForm.FormOldHeight = ThisForm.Height
  
  DoResizeControls = True
  Exit Function
Exc_Handler:
  If Err Then
    MsgBox Err.Description & vbCrLf & "Source: " & Err.Source
  End If
  DoResizeControls = False

End Function

'This sub actually makes the resizing
Private Sub DoResizeChildControls(ByRef ContainerForm As Form, ByRef ParentObject As Object, ByVal OldWidth As Long, ByVal OldHeight As Long)
  Dim ctr As Control
  'Save the old size
  Dim plngOldWidth As Long
  Dim plngOldHeight As Long
  Dim penmAnchor As enmResizing
  'Step through each controls of the form
  For Each ctr In ContainerForm
    'Resizing to the given control
    If IsControlResizable(ctr) Then
      If ctr.Container Is ParentObject Then
        If IsNull(ctr.Tag) Or ctr.Tag = "" Then
          penmAnchor = eAnchorTo_TopLeft
        Else
          penmAnchor = ctr.Tag
        End If
        'only if not default (TopLeft)
        If penmAnchor <> eAnchorTo_TopLeft Then
          'save the original size
          plngOldHeight = ctr.Height
          plngOldWidth = ctr.Width
          'Calculate size roperties
          'Left
          If penmAnchor = eAnchorTo_TopRight _
          Or penmAnchor = eAnchorTo_BottomRight Then
            ctr.Left = ctr.Left + ParentObject.Width - OldWidth
          End If
          'Top
          If penmAnchor = eAnchorTo_BottomRight _
          Or penmAnchor = eAnchorTo_BottomLeft _
          Or penmAnchor = eAnchorTo_BottomLeftRight Then
            ctr.Top = ctr.Top + ParentObject.Height - OldHeight
          End If
          'Width
          If penmAnchor = eAnchorTo_BottomLeftRight _
          Or penmAnchor = eAnchorTo_TopLeftRight _
          Or penmAnchor = eAnchorTo_All Then
            ctr.Width = ctr.Width + ParentObject.Width - OldWidth
          End If
          'Height
          If penmAnchor = eAnchorTo_TopBottomLeft _
          Or penmAnchor = eAnchorTo_TopBottomRight _
          Or penmAnchor = eAnchorTo_All Then
            ctr.Height = ctr.Height + ParentObject.Height - OldHeight
          End If
          'recursive call to all the child controls
          If IsControlHasChildControl(ContainerForm, ctr) Then
            Call DoResizeChildControls(ContainerForm, ctr, plngOldWidth, plngOldHeight)
          End If
        End If
      End If
    End If
  Next
    
End Sub

'Find out if the control contains some other controls
Private Function IsControlHasChildControl(ByRef ParentForm As Form, ByRef ControlInQuestion As Object) As Boolean
  Dim ctr As Control
      
  For Each ctr In ParentForm
    If IsControlResizable(ctr) Then
      If ctr.Container Is ControlInQuestion Then
        IsControlHasChildControl = True
        Exit Function
      End If
    End If
  Next

  IsControlHasChildControl = False
      
End Function

'Function to filter out the controls that can not be resized
'Should turn up any problem with resizing, this is the function
'where you should tune the module
'Note: this function contains some unelegant hacking
'if you find another solution please let me know
Private Function IsControlResizable(ByRef ctr As Control) As Boolean
  On Error GoTo Exc_Handler
  
  Dim vTagValue As Variant
  Dim oContainer As Object
  
  'Control must be a Tag property
  vTagValue = ctr.Tag
  'Control must be a Container property
  Set oContainer = ctr.Container
  'Control set not to be involved in resizing
  If vTagValue = enmResizing.eAnchorTo_Nothing Then
    GoTo Exc_Handler
  End If
  
  IsControlResizable = True
  
  Exit Function
Exc_Handler:
  IsControlResizable = False
End Function
